;;;;
;;;; Gtk-Server Example
;;;; By Leonardo Cecchi
;;;;

(defpackage :example-four
  (:use :common-lisp :gtk-server)
  (:export :main))

(in-package :example-four)

(defun main ()
  "Simple example form"
  (with-gtk-server ()
    (with-components
	((win (window 0))
	 (lb-name (label "Name:"))
	 (en-name (entry))
	 (hb-box (hbox 0 2))
	 (vb-box (vbox 0 2))
	 (bt-ok (button "Ok")))

      ;; Window initialize
      (gtk_window_set_title win "Hello window with dialog!")
      (with-pack-in hb-box
	((:padding 2 :expand 0 :fill 0) lb-name)
	((:padding 2 :expand 1 :fill 1) en-name))
      (with-pack-in vb-box
	((:padding 2 :expand 0 :fill 0) hb-box)
	((:padding 2 :expand 0 :fill 0) bt-ok))
      (gtk_container_add win vb-box)
      (gtk_widget_show_all win)

      ;; Window event loop
      (with-event-loop my-event
	(win
	 (return))
	(bt-ok
	 (let ((name (gtk_entry_get_text en-name)))
	   (cond
	     ((= (length (string-trim " " name)) 0)
	      (show-error-dialog win "Please insert a name!"))
	     (t (show-info-dialog win
				  (format nil "Hi, ~a~%" name))
		(return)))))))))
