;;;;
;;;; Gtk-Server Example
;;;; By Leonardo Cecchi
;;;;

(defpackage :example-three
  (:use :common-lisp :gtk-server)
  (:export :main))

(in-package :example-three)

(defun main ()
  "Simple example. Window with menu"
  (with-gtk-server '()
    (with-components ((win (window 0))
		      (text (textview))
		      (scroll (scrolledwindow))
		      (menubar (menubar))
		      (vbox (vbox 0 0))
		      ;; File Menu
		      (mnu-file (menu))
		      (itm-file (menuitem-l "File"))
		      (itm-open (menuitem-l "Open"))
		      (itm-save (menuitem-l "Save"))
		      (itm-exit (menuitem-l "Exit"))
		      ;; Edit menu
		      (mnu-edit (menu))
		      (itm-edit (menuitem-l "Edit"))
		      (itm-copy (menuitem-l "Copy"))
		      (itm-paste (menuitem-l "Paste"))
		      (itm-cut (menuitem-l "Cut")))

      ;; Create menu
      (append-in-menu mnu-file itm-open itm-save itm-exit)
      (gtk_menu_item_set_submenu itm-file mnu-file)
      (append-in-menu mnu-edit itm-copy itm-paste itm-cut)
      (gtk_menu_item_set_submenu itm-edit mnu-edit)
      (append-in-menu menubar itm-file itm-edit)

      ;; Insert widgets in window
      (gtk_container_add scroll text)
      (with-pack-in vbox
	((:padding 0 :expand 0 :fill 1) menubar)
	((:padding 2 :expand 1 :fill 1) scroll))
      (gtk_window_set_title win "Menu Test")
      (gtk_container_add win vbox)

      ;; Show All
      (gtk_widget_show_all win)

      ;; Event loop
      (with-event-loop my-event
	(win
	 (return))
	(itm-exit
	 (return))))))
