;;;;
;;;; Gtk-Server Example
;;;; By Leonardo Cecchi
;;;;

(defpackage :example-two
  (:use :common-lisp :gtk-server)
  (:export :main))

(in-package :example-two)

(defun main ()
  (with-gtk-server '()
      (with-components ((win (window 0))
			(bt-ok (button "Ok"))
			(bt-cancel (button "Cancel"))
			(bt-esci (button "Exit"))
			(hbox (hbox 1 2))
			(vboxt (vbox 1 2))
			(vbox (vbox 0 2))
			(scrollt1 (scrolledwindow))
			(scrollt2 (scrolledwindow))
			(text2 (textview))
			(text (textview)))
	(gtk_container_add scrollt1 text)
	(gtk_container_add scrollt2 text2)
	(gtk_window_set_title win "Test window")
	(with-pack-in hbox
	  ((:padding 0 :fill 1 :expand 1) bt-ok)
	  ((:padding 0 :fill 1 :expand 1) bt-cancel)
	  ((:padding 0 :fill 1 :expand 1) bt-esci))
	
	(with-pack-in vboxt
	  ((:padding 2 :fill 1 :expand 1) scrollt1)
	  ((:padding 2 :fill 1 :expand 1) scrollt2))

	(with-pack-in vbox
	  ((:padding 2 :fill 1 :expand 1) vboxt)
	  ((:padding 2 :fill 0 :expand 0) hbox))
	
	(gtk_text_view_set_text text "Hello from Me!")
	(gtk_text_view_set_text text2 "Another textview")
	(gtk_container_add win vbox)
	(gtk_widget_show_all win)

	(with-event-loop my-event
	  (win
	   (return))
	  (bt-ok
	   (format t "Ok button")
	   (return))
	  (bt-cancel
	   (format t "Cancel button")
	   (return))
	  (bt-esci
	   (format t "Exit button")
	   (return))))))
